---
title: BigInt64Array() constructor
slug: Web/JavaScript/Reference/Global_Objects/BigInt64Array/BigInt64Array
tags:
  - BigInt
  - Constructor
  - JavaScript
  - Reference
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>BigInt64Array()</code></strong> typed array constructor creates a new {{jsxref("BigInt64Array")}} object, which is, an array of 64-bit signed integers in the platform byte order. If control over byte order is needed, use {{jsxref("DataView")}} instead. The contents are initialized to <code>0n</code>. Once established, you can reference elements in the array using the object's methods, or by using standard array index syntax (that is, using bracket notation).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">new BigInt64Array();
new BigInt64Array(<var>length</var>);
new BigInt64Array(<var>typedArray</var>);
new BigInt64Array(<var>object</var>);
new BigInt64Array(<var>buffer</var> [, <var>byteOffset</var> [, <var>length</var>]]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>length</var></code></dt>
 <dd>When called with a <code><var>length</var></code> argument, an internal array buffer is created in memory, of size <code><var>length</var></code><em> multiplied by <code>BYTES_PER_ELEMENT</code></em> bytes, containing zeros.</dd>
 <dt><code><var>typedArray</var></code></dt>
 <dd>When called with a <code><var>typedArray</var></code> argument, which can be an object of any of the typed array types (such as <code>Int32Array</code>), the <code><var>typedArray</var></code> gets copied into a new typed array. Each value in <code><var>typedArray</var></code> is converted to the corresponding type of the constructor before being copied into the new array. The length of the new typed array will be same as the length of the <code><var>typedArray</var></code> argument.</dd>
 <dt><code><var>object</var></code></dt>
 <dd>When called with an <code><var>object</var></code> argument, a new typed array is created as if by the <code><var>TypedArray</var>.from()</code> method.</dd>
 <dt><code><var>buffer</var></code>, <code><var>byteOffset</var></code>, <code><var>length</var></code></dt>
 <dd>When called with a <code><var>buffer</var></code>, and optionally a <code><var>byteOffset</var></code> and a <code><var>length</var></code> argument, a new typed array view is created that views the specified {{jsxref("ArrayBuffer")}}. The <code><var>byteOffset</var></code> and <code><var>length</var></code> parameters specify the memory range that will be exposed by the typed array view. If both are omitted, all of <code><var>buffer</var></code> is viewed; if only <code><var>length</var></code> is omitted, the remainder of <code><var>buffer</var></code> is viewed.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Different_ways_to_create_a_BigInt64Array">Different ways to create a BigInt64Array</h3>

<pre class="brush: js">// From a length
var bigint64 = new BigInt64Array(2);
bigint64[0] = 42n;
console.log(bigint64[0]); // 42n
console.log(bigint64.length); // 2
console.log(bigint64.BYTES_PER_ELEMENT); // 8

// From an array
var arr = new BigInt64Array([21n,31n]);
console.log(arr[1]); // 31n

// From another TypedArray
var x = new BigInt64Array([21n, 31n]);
var y = new BigInt64Array(x);
console.log(y[0]); // 21n

// From an ArrayBuffer
var buffer = new ArrayBuffer(32);
var z = new BigInt64Array(buffer, 0, 4);

// From an iterable
var iterable = function*(){ yield* [1n, 2n, 3n]; }();
var bigint64 = new BigInt64Array(iterable);
// BigInt64Array[1n, 2n, 3n]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("ESDraft", "#sec-typedarray-constructors", "BigInt64Array")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.BigInt64Array.BigInt64Array")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Typed_arrays" title="en/JavaScript typed arrays">JavaScript typed arrays</a></li>
 <li>{{jsxref("BigUint64Array")}}</li>
 <li>{{jsxref("DataView")}}</li>
</ul>
